// Menu Class - using popupMenu(), 21 October, 2012, Copyright 2004-2012 Harry Whitfield
//////////////////////////////////////////////////////////////////////////////////////////
var Menu = (function () {
    function Menu(menuImage, menuStringsArray, selectedString, menuActionFunction) {
        var i;
        this.image = menuImage;
        this.menus = [];
        for(i = 0; i < menuStringsArray.length; i += 1) {
            this.menus[i] = menuStringsArray[i];
        }
        this.selected = selectedString;
        this.menuAction = menuActionFunction;
        this.hOffset = menuImage.hOffset;
        this.vOffset = menuImage.vOffset;
    }
    Menu.prototype.reset = function (menuStringsArray, selectedString) {
        var i;
        this.menus = null;
        this.menus = [];
        for(i = 0; i < menuStringsArray.length; i += 1) {
            this.menus[i] = menuStringsArray[i];
        }
        this.selected = selectedString;
    };
    Menu.prototype.show = function (opacity) {
        this.image.opacity = opacity;
    };
    Menu.prototype.setTick = function (selected) {
        this.selected = selected;
    };
    Menu.prototype.select = function () {
        var menuItems = [];
        var items;
        var that = this.menus;

        for(items in that) {
            if(that.hasOwnProperty(items)) {
                menuItems[items] = new MenuItem();
                menuItems[items].title = that[items];
                menuItems[items].checked = (this.selected === that[items]);
                menuItems[items].i = items;
                menuItems[items].data = that[items];
                menuItems[items].onSelect = this.menuAction;
            }
        }
        popupMenu(menuItems, this.hOffset, this.vOffset);
        updateNow();
    };
    return Menu;
})();
//////////////////////////////////////////////////////////////////////////////////////////
var modeMenu;
function modeMenuAction() {
    //	(i, data)	// define the action function for modeMenu
        var i = this.i;
    var data = this.data;

    print("Index(i): " + i + " Data: " + data);
    modeMenu.setTick(data);
}
var modeText = [
    'Coil Diameter', 
    'Number of Turns', 
    'Length of Coil', 
    'Coil Inductance'
];
var menuStringsArray = modeText;// define the array of menuStrings

var selectedString = modeText[3];// define the initially selected string, or set to ""

var menuActionFunction = modeMenuAction;// define the name of the menuAction function - must be a function

var menuImage = image1;
modeMenu = new Menu(menuImage, menuStringsArray, selectedString, menuActionFunction)// call the menu constructor
;
menuImage.onMouseDown = function () {
    if(system.platform === "macintosh") {
        modeMenu.select();
    }
};
menuImage.onMouseUp = function () {
    if(system.platform !== "macintosh") {
        modeMenu.select();
    }
};
