///////////////////////////////// interface declarations /////////////////////////////////

declare var main_window: Window;


////////////// end ////////////// interface declarations ////////////// end //////////////

/*
	Traffic Light - version 0.2
	17 October, 2012
	Copyright 2012 Harry Whitfield
	mailto:g6auc@arrl.net
*/

///////////////////////////////////////////////////////////////

class Cimage {
	constructor (parent: any, src: string, hOffset: number, vOffset: number, width: number, height: number, hAlign: string, opacity: number, visible: bool) {
		var o = new Image();
		o.src      = src;
		o.hOffset  = hOffset;
		o.vOffset  = vOffset;
		o.width    = width;
		o.height   = height;
		o.hAlign   = hAlign;
		o.opacity  = opacity;
		o.visible  = visible;
		parent.appendChild(o);
		return o;
	}
}

class  Traffic_Light {
	public frame: Frame;
	public back: Image;
	public red: Image;
	public amber: Image;
	public green: Image;
	
	constructor (parent: any, hOffset: number, vOffset: number, zOrder: number) {
		var	frame = new Frame();

		frame.hOffset = hOffset;
		frame.vOffset = vOffset;
		frame.zOrder  = zOrder;
		parent.appendChild(frame);
		
		this.frame = frame;

		this.back  = new Cimage(frame, "Resources/Traffic_Light/back.png",   0,  0, 22, 69, "left", 255, true);
		this.red   = new Cimage(frame, "Resources/Traffic_Light/red.png",    4,  8, 14, 20, "left", 255, false);
		this.amber = new Cimage(frame, "Resources/Traffic_Light/amber.png",  4, 28, 14, 20, "left", 255, false);
		this.green = new Cimage(frame, "Resources/Traffic_Light/green.png",  4, 48, 14, 14, "left", 255, false);
	}
	
	setAspect(aspect: string) {
		this.red.visible = this.amber.visible = this.green.visible = false;
		switch (aspect) {
		case "off":				// 0
			break;
		case "green":			// 1
			this.green.visible = true;
			break;
		case "amber":			// 2
			this.amber.visible = true;
			break;
		case "amber_green":		// 3
			this.amber.visible = true;
			this.green.visible = true;
			break;
		case "red":				// 4
			this.red.visible = true;
			break;
		case "red_green":		// 5
			this.red.visible   = true;
			this.green.visible = true;
			break;
		case "red_amber":		// 6
			this.red.visible   = true;
			this.amber.visible = true;
			break;
		case "red_amber_green":	// 7
			this.red.visible   = true;
			this.amber.visible = true;
			this.green.visible = true;
			break;
		}
	}
}

var traffic_Light = new Traffic_Light(main_window,  0, main_window.height + 5, 100);
traffic_Light.frame.visible = true;
traffic_Light.setAspect("red_amber_green");
main_window.height += 75;
